Description: Use CPPFLAGS/CFLAGS/CXXFLAGS for hardening.
Author: Doug Torrance <dtorrance@debian.org>
Bug: https://github.com/janverschelde/PHCpack/issues/54
Last-Update: 2021-02-27

--- a/src/Objects/makefile_unix
+++ b/src/Objects/makefile_unix
@@ -3021,13 +3021,13 @@
 
 parameter.o:
 	$(gpp) -O3 -fPIC -I$(PHCgpu)/Path/Host2 \
-               -c $(PHCgpu)/Path/Host2/parameter.cpp -o parameter.o
+               -c $(CPPFLAGS) $(CXXFLAGS) $(PHCgpu)/Path/Host2/parameter.cpp -o parameter.o
 
 lib2path_d.o:
 	$(gpp) -O3 -fPIC -I$(PHCLib) \
                          -I$(PHCgpu)/Path/Complex -I$(PHCgpu)/Path/Poly3 \
                          -I$(PHCgpu)/Path/Host2 \
-               -c $(PHCgpu)/Path/Host2/lib2path_d.cpp -o lib2path_d.o
+               -c $(CPPFLAGS) $(CXXFLAGS) $(PHCgpu)/Path/Host2/lib2path_d.cpp -o lib2path_d.o
 
 lib2path.o:
 	$(gpp) -O3 -fPIC -I$(PHCLib) -I$(QD_ROOT)/include \
@@ -4065,56 +4065,56 @@
 
 phcpy2c3.so: parameter.o lib2path_d.o
 	/bin/rm -f -r phcpy2c2.o phcpy2c2.a phcpy2c3.o phcpy2c3.a
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/syscon.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/tabform.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/solcon.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/product.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 \
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/syscon.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/tabform.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/solcon.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/product.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) \
                $(PHCLib)/lists_and_strings.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/celcon.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/intcelcon.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/scalers.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/reducers.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/sweep.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/multiplicity.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/numbtrop.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/witset.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/witsols.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/unisolvers.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/giftwrappers.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/phcpack.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/schubert.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/mapcon.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/series.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/padcon.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/syspool.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/jump_track.c
-	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(PHCLib)/next_track.c
-	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/celcon.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/intcelcon.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/scalers.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/reducers.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/sweep.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/multiplicity.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/numbtrop.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/witset.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/witsols.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/unisolvers.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/giftwrappers.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/phcpack.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/schubert.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/mapcon.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/series.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/padcon.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/syspool.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/jump_track.c
+	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 $(CPPFLAGS) $(CXXFLAGS) $(PHCLib)/next_track.c
+	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/inputData.cpp
-	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/outputData.cpp
-	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/iTest.cpp
-	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/fTest.cpp
-	$(gpp) -Dcompilewgpp=1 -Dcompile4phc=1 -static -fPIC $(DEMiCS_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -Dcompile4phc=1 -static -fPIC $(DEMiCS_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/simplex.cpp -o simplex4phc.o
-	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/reltab.cpp
-	$(gpp) -Dcompilewgpp=1 -Dcompile4phc=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -Dcompile4phc=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/mvc.cpp -o mvc4phc.o
-	$(gpp) -Dcompilewgpp=1 -Dcompile4phc=1 -static -fPIC $(DEMiCs_CFLAGS) \
+	$(gpp) -Dcompilewgpp=1 -Dcompile4phc=1 -static -fPIC $(DEMiCs_CFLAGS) $(CPPFLAGS) $(CXXFLAGS) \
                -c $(PHCAda)/Root_Counts/DEMiCs/demicsrun.cpp -o demicsrun4phc.o
 	$(gpp) -Dcompilewgpp=1 -static -c -fPIC -O3 -I$(PYTHON3) -I$(PHCLib) \
                -I$(PHCgpu)/Path/Complex -I$(PHCgpu)/Path/Host2 \
-               -I$(PHCgpu)/Path/Poly3 $(PHCmod)/phcpy2c3.c
+               -I$(PHCgpu)/Path/Poly3 $(CPPFLAGS) $(CXXFLAGS) $(PHCmod)/phcpy2c3.c
 	gnatmake -static -c -fPIC $(INCLULIBS) $(GNATFLAGS) use_c2phc.adb
 	gnatbind -n -static use_c2phc -o use_c2phc_binder.adb
 	gnatmake -static -c -fPIC $(INCLULIBS) $(GNATFLAGS) use_c2phc_binder.adb
 	ar ruv phcpy2c3.a *.o
 	ranlib phcpy2c3.a
-	$(gpp) -shared -o ../Python/PHCpy3/phcpy/phcpy2c3.so -lm \
+	$(gpp) $(LDFLAGS) -shared -o ../Python/PHCpy3/phcpy/phcpy2c3.so -lm \
             -Wl,-whole-archive phcpy2c3.a \
             -lgnat -lgnarl \
             -Wl,-no-whole-archive -lrt
--- a/src/Ada/Main/main.gpr
+++ b/src/Ada/Main/main.gpr
@@ -149,24 +149,32 @@
 
     package Compiler is
 
-       -- for Default_Switches ("Ada") use ("-gnatwa", "-gnatva");
-        for Default_Switches ("Ada") use ("-O3", "-gnatv", "-gnatp", "-gnatf");
+        for Default_Switches ("C++") use External_As_List ("CPPFLAGS", " ") &
+            External_As_List ("CXXFLAGS", " ");
+        for Default_Switches ("C") use External_As_List ("CPPFLAGS", " ") &
+            External_As_List ("CFLAGS", " ");
+        for Default_Switches ("Ada") use External_As_List ("ADAFLAGS", " ");
 
         for Switches ("use_c2phc.adb") use ("-c");
 
         for Switches ("simplex.cpp") use 
         (
             "-Dcompilewgpp=1", "-Dcompile4phc=1"
-        );
+        ) & External_As_List ("CPPFLAGS", " ") &
+            External_As_List ("CXXFLAGS", " ");
         for Switches ("mvc.cpp") use
         (
             "-Dcompilewgpp=1", "-Dcompile4phc=1"
-        );
+        ) & External_As_List ("CPPFLAGS", " ") &
+            External_As_List ("CXXFLAGS", " ");
         for Switches ("demicsrun.cpp") use 
         (
             "-Dcompilewgpp=1", "-Dcompile4phc"
-        );
-        for Switches ("outputData.cpp") use ("-Dcompilewgpp=1");
+        ) & External_As_List ("CPPFLAGS", " ") &
+            External_As_List ("CXXFLAGS", " ");
+        for Switches ("outputData.cpp") use ("-Dcompilewgpp=1") &
+            External_As_List ("CPPFLAGS", " ") &
+            External_As_List ("CXXFLAGS", " ");
 
     end Compiler;
 
@@ -179,6 +187,7 @@
     end Binder;
 
     package Linker is
+        for Default_Switches ("Ada") use External_As_List ("LDFLAGS", " ");
 
         for Switches ("main.cpp") use ("-o demics");
 
